function midi_for_light() {}
var vu_array_fill_counter = 1;
var vu_array_fill_maximum = 50; // 25 = 1sec; 50 = 2sec;
var vu_array_mono = new Array(vu_array_fill_maximum);
var vu_array_left = new Array(vu_array_fill_maximum);
var vu_array_right = new Array(vu_array_fill_maximum);

midi_for_light.init = function(id) {	// called when the MIDI device is opened & set up
	midi_for_light.id = id;	// Store the ID of this device for later use
	midi_for_light.directoryMode = false;
  midi_for_light.deckaktuell = 0;
	midi_for_light.fadersperre = false;
	midi_for_light.CrossfaderChangeSperreTimer = [-1, -1];
	midi_for_light.volumebeat = false;
	midi_for_light.volumebeatsperre = false;
	midi_for_light.VolumeBeatSperreTimer = [-1, -1];
	midi_for_light.VuMeterTimer = [-1, -1];
	
	engine.connectControl("[Channel1]", "beat_active", "midi_for_light.Deck1BeatOutputToMidi");
	engine.connectControl("[Channel2]", "beat_active", "midi_for_light.Deck2BeatOutputToMidi");
	engine.connectControl("[Channel1]", "playposition", "midi_for_light.Deck1PostionChange");
	engine.connectControl("[Channel2]", "playposition", "midi_for_light.Deck2PostionChange");
	engine.connectControl("[Master]", "crossfader", "midi_for_light.CrossfaderChange");
	engine.connectControl("[Channel1]", "volume", "midi_for_light.Deck1VolumeChange");
	engine.connectControl("[Channel2]", "volume", "midi_for_light.Deck2VolumeChange");

	midi_for_light.VuMeterTimer = engine.beginTimer(40,"midi_for_light.VuMeter()");

}

midi_for_light.shutdown = function(id) {	// called when the MIDI device is closed
}

midi_for_light.VuMeter= function() {
  // Outputwerte fr MIDI festlegen (Range)
  var vu_out_min = 0;
  var vu_out_max = 127;
  var vu_out_range = vu_out_max - vu_out_min;
  // Aktuelle Werte holen und setzen
  var vu_mono_current = engine.getValue("[Master]", "VuMeter");
  var vu_left_current = engine.getValue("[Master]", "VuMeterL");
  var vu_right_current = engine.getValue("[Master]", "VuMeterR");

  // Arrayzaehler verwalten
  vu_array_fill_counter++;
	if (vu_array_fill_counter > vu_array_fill_maximum) { // Zhlerobergrenze
    vu_array_fill_counter = 1;
	}

  // Aktuelle Werte ins Arry schreiben
  vu_array_mono[vu_array_fill_counter] = vu_mono_current;
  vu_array_left[vu_array_fill_counter] = vu_left_current;
  vu_array_right[vu_array_fill_counter] = vu_right_current;

  // Min- Maxwert ermitteln
  var vu_mono_average_min = vu_array_mono[1];
  var vu_mono_average_mid = 0; 
  var vu_mono_average_max = vu_array_mono[1];
  var vu_left_average_min = vu_array_left[1];
  var vu_left_average_mid = 0; 
  var vu_left_average_max = vu_array_left[1];
  var vu_right_average_min = vu_array_right[1];
  var vu_right_average_mid = 0; 
  var vu_right_average_max = vu_array_right[1];
  var z = 1;
  while ( z < vu_array_fill_maximum) {
    // mono
    if ( vu_array_mono[z] < vu_mono_average_min) vu_mono_average_min = vu_array_mono[z];
    vu_mono_average_mid = vu_mono_average_mid + vu_array_mono[z];
    if ( vu_array_mono[z] > vu_mono_average_max) vu_mono_average_max = vu_array_mono[z];
    // left
    if ( vu_array_left[z] < vu_left_average_min) vu_left_average_min = vu_array_left[z];
    vu_left_average_mid = vu_left_average_mid + vu_array_left[z];
    if ( vu_array_left[z] > vu_left_average_max) vu_left_average_max = vu_array_left[z];
    // right
    if ( vu_array_right[z] < vu_right_average_min) vu_right_average_min = vu_array_right[z];
    vu_right_average_mid = vu_right_average_mid + vu_array_right[z];
    if ( vu_array_right[z] > vu_right_average_max) vu_right_average_max = vu_array_right[z];
    z++;
  }
  vu_mono_average_mid = vu_mono_average_mid / vu_array_fill_maximum;
  vu_left_average_mid = vu_left_average_mid / vu_array_fill_maximum;
  vu_right_average_mid = vu_right_average_mid / vu_array_fill_maximum;
  
  // Werte average_fit berechnen
  vu_mono_average_fit = (vu_mono_current - vu_mono_average_min) / (vu_mono_average_max - vu_mono_average_min);
  vu_left_average_fit = (vu_left_current - vu_left_average_min) / (vu_left_average_max - vu_left_average_min);
  vu_right_average_fit = (vu_right_current - vu_right_average_min) / (vu_right_average_max - vu_right_average_min);

  // Vu-Meter berechnen
  var vu_mono_current_meter1 = (vu_mono_current * 4) - 0;
  if ( vu_mono_current_meter1 < 0 ) vu_mono_current_meter1 = 0;
  if ( vu_mono_current_meter1 > 1 ) vu_mono_current_meter1 = 1;
  var vu_mono_current_meter2 = (vu_mono_current * 4) - 1;
  if ( vu_mono_current_meter2 < 0 ) vu_mono_current_meter2 = 0;
  if ( vu_mono_current_meter2 > 1 ) vu_mono_current_meter2 = 1;
  var vu_mono_current_meter3 = (vu_mono_current * 4) - 2;
  if ( vu_mono_current_meter3 < 0 ) vu_mono_current_meter3 = 0;
  if ( vu_mono_current_meter3 > 1 ) vu_mono_current_meter3 = 1;
  var vu_mono_current_meter4 = (vu_mono_current * 4) - 3;
  if ( vu_mono_current_meter4 < 0 ) vu_mono_current_meter4 = 0;
  if ( vu_mono_current_meter4 > 1 ) vu_mono_current_meter4 = 1;
  var vu_mono_average_meter1 = (vu_mono_average_fit * 4) - 0;
  if ( vu_mono_average_meter1 < 0 ) vu_mono_average_meter1 = 0;
  if ( vu_mono_average_meter1 > 1 ) vu_mono_average_meter1 = 1;
  var vu_mono_average_meter2 = (vu_mono_average_fit * 4) - 1;
  if ( vu_mono_average_meter2 < 0 ) vu_mono_average_meter2 = 0;
  if ( vu_mono_average_meter2 > 1 ) vu_mono_average_meter2 = 1;
  var vu_mono_average_meter3 = (vu_mono_average_fit * 4) - 2;
  if ( vu_mono_average_meter3 < 0 ) vu_mono_average_meter3 = 0;
  if ( vu_mono_average_meter3 > 1 ) vu_mono_average_meter3 = 1;
  var vu_mono_average_meter4 = (vu_mono_average_fit * 4) - 3;
  if ( vu_mono_average_meter4 < 0 ) vu_mono_average_meter4 = 0;
  if ( vu_mono_average_meter4 > 1 ) vu_mono_average_meter4 = 1;

  var vu_left_current_meter1 = (vu_left_current * 4) - 0;
  if ( vu_left_current_meter1 < 0 ) vu_left_current_meter1 = 0;
  if ( vu_left_current_meter1 > 1 ) vu_left_current_meter1 = 1;
  var vu_left_current_meter2 = (vu_left_current * 4) - 1;
  if ( vu_left_current_meter2 < 0 ) vu_left_current_meter2 = 0;
  if ( vu_left_current_meter2 > 1 ) vu_left_current_meter2 = 1;
  var vu_left_current_meter3 = (vu_left_current * 4) - 2;
  if ( vu_left_current_meter3 < 0 ) vu_left_current_meter3 = 0;
  if ( vu_left_current_meter3 > 1 ) vu_left_current_meter3 = 1;
  var vu_left_current_meter4 = (vu_left_current * 4) - 3;
  if ( vu_left_current_meter4 < 0 ) vu_left_current_meter4 = 0;
  if ( vu_left_current_meter4 > 1 ) vu_left_current_meter4 = 1;
  var vu_left_average_meter1 = (vu_left_average_fit * 4) - 0;
  if ( vu_left_average_meter1 < 0 ) vu_left_average_meter1 = 0;
  if ( vu_left_average_meter1 > 1 ) vu_left_average_meter1 = 1;
  var vu_left_average_meter2 = (vu_left_average_fit * 4) - 1;
  if ( vu_left_average_meter2 < 0 ) vu_left_average_meter2 = 0;
  if ( vu_left_average_meter2 > 1 ) vu_left_average_meter2 = 1;
  var vu_left_average_meter3 = (vu_left_average_fit * 4) - 2;
  if ( vu_left_average_meter3 < 0 ) vu_left_average_meter3 = 0;
  if ( vu_left_average_meter3 > 1 ) vu_left_average_meter3 = 1;
  var vu_left_average_meter4 = (vu_left_average_fit * 4) - 3;
  if ( vu_left_average_meter4 < 0 ) vu_left_average_meter4 = 0;
  if ( vu_left_average_meter4 > 1 ) vu_left_average_meter4 = 1;

  var vu_right_current_meter1 = (vu_right_current * 4) - 0;
  if ( vu_right_current_meter1 < 0 ) vu_right_current_meter1 = 0;
  if ( vu_right_current_meter1 > 1 ) vu_right_current_meter1 = 1;
  var vu_right_current_meter2 = (vu_right_current * 4) - 1;
  if ( vu_right_current_meter2 < 0 ) vu_right_current_meter2 = 0;
  if ( vu_right_current_meter2 > 1 ) vu_right_current_meter2 = 1;
  var vu_right_current_meter3 = (vu_right_current * 4) - 2;
  if ( vu_right_current_meter3 < 0 ) vu_right_current_meter3 = 0;
  if ( vu_right_current_meter3 > 1 ) vu_right_current_meter3 = 1;
  var vu_right_current_meter4 = (vu_right_current * 4) - 3;
  if ( vu_right_current_meter4 < 0 ) vu_right_current_meter4 = 0;
  if ( vu_right_current_meter4 > 1 ) vu_right_current_meter4 = 1;
  var vu_right_average_meter1 = (vu_right_average_fit * 4) - 0;
  if ( vu_right_average_meter1 < 0 ) vu_right_average_meter1 = 0;
  if ( vu_right_average_meter1 > 1 ) vu_right_average_meter1 = 1;
  var vu_right_average_meter2 = (vu_right_average_fit * 4) - 1;
  if ( vu_right_average_meter2 < 0 ) vu_right_average_meter2 = 0;
  if ( vu_right_average_meter2 > 1 ) vu_right_average_meter2 = 1;
  var vu_right_average_meter3 = (vu_right_average_fit * 4) - 2;
  if ( vu_right_average_meter3 < 0 ) vu_right_average_meter3 = 0;
  if ( vu_right_average_meter3 > 1 ) vu_right_average_meter3 = 1;
  var vu_right_average_meter4 = (vu_right_average_fit * 4) - 3;
  if ( vu_right_average_meter4 < 0 ) vu_right_average_meter4 = 0;
  if ( vu_right_average_meter4 > 1 ) vu_right_average_meter4 = 1;

 
  // Werte fr Ausgabebereich umrechnen
  vu_mono_current = (vu_mono_current * vu_out_range) + vu_out_min;
  vu_mono_average_min = (vu_mono_average_min * vu_out_range) + vu_out_min;
  vu_mono_average_mid = (vu_mono_average_mid * vu_out_range) + vu_out_min;
  vu_mono_average_max = (vu_mono_average_max * vu_out_range) + vu_out_min;
  vu_mono_average_fit = (vu_mono_average_fit * vu_out_range) + vu_out_min;
  vu_mono_current_meter1 = (vu_mono_current_meter1 * vu_out_range) + vu_out_min;
  vu_mono_current_meter2 = (vu_mono_current_meter2 * vu_out_range) + vu_out_min;
  vu_mono_current_meter3 = (vu_mono_current_meter3 * vu_out_range) + vu_out_min;
  vu_mono_current_meter4 = (vu_mono_current_meter4 * vu_out_range) + vu_out_min;
  vu_mono_average_meter1 = (vu_mono_average_meter1 * vu_out_range) + vu_out_min;
  vu_mono_average_meter2 = (vu_mono_average_meter2 * vu_out_range) + vu_out_min;
  vu_mono_average_meter3 = (vu_mono_average_meter3 * vu_out_range) + vu_out_min;
  vu_mono_average_meter4 = (vu_mono_average_meter4 * vu_out_range) + vu_out_min;

  vu_left_current = (vu_left_current * vu_out_range) + vu_out_min;
  vu_left_average_min = (vu_left_average_min * vu_out_range) + vu_out_min;
  vu_left_average_mid = (vu_left_average_mid * vu_out_range) + vu_out_min;
  vu_left_average_max = (vu_left_average_max * vu_out_range) + vu_out_min;
  vu_left_average_fit = (vu_left_average_fit * vu_out_range) + vu_out_min;
  vu_left_current_meter1 = (vu_left_current_meter1 * vu_out_range) + vu_out_min;
  vu_left_current_meter2 = (vu_left_current_meter2 * vu_out_range) + vu_out_min;
  vu_left_current_meter3 = (vu_left_current_meter3 * vu_out_range) + vu_out_min;
  vu_left_current_meter4 = (vu_left_current_meter4 * vu_out_range) + vu_out_min;
  vu_left_average_meter1 = (vu_left_average_meter1 * vu_out_range) + vu_out_min;
  vu_left_average_meter2 = (vu_left_average_meter2 * vu_out_range) + vu_out_min;
  vu_left_average_meter3 = (vu_left_average_meter3 * vu_out_range) + vu_out_min;
  vu_left_average_meter4 = (vu_left_average_meter4 * vu_out_range) + vu_out_min;

  vu_right_current = (vu_right_current * vu_out_range) + vu_out_min;
  vu_right_average_min = (vu_right_average_min * vu_out_range) + vu_out_min;
  vu_right_average_mid = (vu_right_average_mid * vu_out_range) + vu_out_min;
  vu_right_average_max = (vu_right_average_max * vu_out_range) + vu_out_min;
  vu_right_average_fit = (vu_right_average_fit * vu_out_range) + vu_out_min;
  vu_right_current_meter1 = (vu_right_current_meter1 * vu_out_range) + vu_out_min;
  vu_right_current_meter2 = (vu_right_current_meter2 * vu_out_range) + vu_out_min;
  vu_right_current_meter3 = (vu_right_current_meter3 * vu_out_range) + vu_out_min;
  vu_right_current_meter4 = (vu_right_current_meter4 * vu_out_range) + vu_out_min;
  vu_right_average_meter1 = (vu_right_average_meter1 * vu_out_range) + vu_out_min;
  vu_right_average_meter2 = (vu_right_average_meter2 * vu_out_range) + vu_out_min;
  vu_right_average_meter3 = (vu_right_average_meter3 * vu_out_range) + vu_out_min;
  vu_right_average_meter4 = (vu_right_average_meter4 * vu_out_range) + vu_out_min;

  // Werte ausgeben
  midi.sendShortMsg(0x90,0x40,vu_mono_current);         // dez.64, okt.5 note E
	midi.sendShortMsg(0x90,0x41,vu_mono_average_min);     // dez.65, okt.5 note F
	midi.sendShortMsg(0x90,0x42,vu_mono_average_mid);     // dez.66, okt.5 note F#
	midi.sendShortMsg(0x90,0x43,vu_mono_average_max);     // dez.67, okt.5 note G
	midi.sendShortMsg(0x90,0x44,vu_mono_average_fit);     // dez.68, okt.5 note G#
	midi.sendShortMsg(0x90,0x45,vu_mono_current_meter1);  // dez.69, okt.5 note A
	midi.sendShortMsg(0x90,0x46,vu_mono_current_meter2);  // dez.70, okt.5 note A#
	midi.sendShortMsg(0x90,0x47,vu_mono_current_meter3);  // dez.71, okt.5 note B
	midi.sendShortMsg(0x90,0x48,vu_mono_current_meter4);  // dez.72, okt.6 note C
	midi.sendShortMsg(0x90,0x49,vu_mono_average_meter1);  // dez.73, okt.6 note C#
	midi.sendShortMsg(0x90,0x4A,vu_mono_average_meter2);  // dez.74, okt.6 note D
	midi.sendShortMsg(0x90,0x4B,vu_mono_average_meter3);  // dez.75, okt.6 note D#
	midi.sendShortMsg(0x90,0x4C,vu_mono_average_meter4);  // dez.76, okt.6 note E
	midi.sendShortMsg(0x90,0x50,vu_left_current);         // dez.80, okt.6 note G#
	midi.sendShortMsg(0x90,0x51,vu_left_average_min);     // dez.81, okt.6 note A
	midi.sendShortMsg(0x90,0x52,vu_left_average_mid);     // dez.82, okt.6 note A#
	midi.sendShortMsg(0x90,0x53,vu_left_average_max);     // dez.83, okt.6 note B
	midi.sendShortMsg(0x90,0x54,vu_left_average_fit);     // dez.84, okt.7 note C
	midi.sendShortMsg(0x90,0x55,vu_left_current_meter1);  // dez.85, okt.7 note C#
	midi.sendShortMsg(0x90,0x56,vu_left_current_meter2);  // dez.86, okt.7 note D
	midi.sendShortMsg(0x90,0x57,vu_left_current_meter3);  // dez.87, okt.7 note D#
	midi.sendShortMsg(0x90,0x58,vu_left_current_meter4);  // dez.88, okt.7 note E
	midi.sendShortMsg(0x90,0x59,vu_left_average_meter1);  // dez.89, okt.7 note F
	midi.sendShortMsg(0x90,0x5A,vu_left_average_meter2);  // dez.90, okt.7 note F#
	midi.sendShortMsg(0x90,0x5B,vu_left_average_meter3);  // dez.91, okt.7 note G
	midi.sendShortMsg(0x90,0x5C,vu_left_average_meter4);  // dez.92, okt.7 note G#
	midi.sendShortMsg(0x90,0x60,vu_right_current);         // dez.96, okt.8 note C
	midi.sendShortMsg(0x90,0x61,vu_right_average_min);     // dez.97, okt.8 note C#
	midi.sendShortMsg(0x90,0x62,vu_right_average_mid);     // dez.98, okt.8 note D
	midi.sendShortMsg(0x90,0x63,vu_right_average_max);     // dez.99, okt.8 note D#
	midi.sendShortMsg(0x90,0x64,vu_right_average_fit);     // dez.100, okt.8 note E
	midi.sendShortMsg(0x90,0x65,vu_right_current_meter1);  // dez.101, okt.8 note F
	midi.sendShortMsg(0x90,0x66,vu_right_current_meter2);  // dez.102, okt.8 note F#
	midi.sendShortMsg(0x90,0x67,vu_right_current_meter3);  // dez.103, okt.8 note G
	midi.sendShortMsg(0x90,0x68,vu_right_current_meter4);  // dez.104, okt.8 note G#
	midi.sendShortMsg(0x90,0x69,vu_right_average_meter1);  // dez.105, okt.8 note A
	midi.sendShortMsg(0x90,0x6A,vu_right_average_meter2);  // dez.106, okt.8 note A#
	midi.sendShortMsg(0x90,0x6B,vu_right_average_meter3);  // dez.107, okt.8 note B
	midi.sendShortMsg(0x90,0x6C,vu_right_average_meter4);  // dez.108, okt.9 note C

}

midi_for_light.Deck1VolumeChange = function() { //Deck wurde geaendert
  if (midi_for_light.volumebeat == false) { // reaus wenn Volumebeat deaktiviert ist
		return;
	}
  if (midi_for_light.volumebeatsperre == true) { // reaus wenn Sperre aktiviert ist
		return;
	}
	// Aktuelle Volumewerte der Decks holen
	deck1volume = engine.getValue("[Channel1]", "volume");
	deck2volume = engine.getValue("[Channel2]", "volume");
	if (deck1volume == deck2volume) { // raus wenn Volume gleich ist
		return;
	}
	// Aktuelles Deck ermitteln
	var deck = 0; 
	if (deck2volume > deck1volume) { // Deck2 Volume ist groesser
		deck = 1;
	}
	// Schauen ob das Deck gewechselt hat
	if (deck != midi_for_light.deckaktuell){
		midi_for_light.deckaktuell = deck;
		midi.sendShortMsg(0x90,0x30,0x64+deck);   // Note C an mit 64 und Deck dazu addiert
		midi_for_light.volumebeatsperre = true;
		midi_for_light.VolumeBeatSperreTimer = engine.beginTimer(1000,"midi_for_light.VolumeBeatSperre()");
	}
}

midi_for_light.Deck2VolumeChange = function() { //Decklaustaerke wurde geaendert
  if (midi_for_light.volumebeat == false) { // reaus wenn Volumebeat deaktiviert ist
		return;
	}
  if (midi_for_light.volumebeatsperre == true) { // reaus wenn Sperre aktiviert ist
		return;
	}
	// Aktuelle Volumewerte der Decks holen
	deck1volume = engine.getValue("[Channel1]", "volume");
	deck2volume = engine.getValue("[Channel2]", "volume");
	if (deck1volume == deck2volume) { // raus wenn Volume gleich ist
		return;
	}
	// Aktuelles Deck ermitteln
	var deck = 0; 
	if (deck2volume > deck1volume) { // Deck2 Volume ist groesser
		deck = 1;
	}
	// Schauen ob das Deck gewechselt hat
	if (deck != midi_for_light.deckaktuell){
		midi_for_light.deckaktuell = deck;
		midi.sendShortMsg(0x90,0x30,0x64+deck);   // Note C an mit 64 und Deck dazu addiert
		midi_for_light.volumebeatsperre = true;
		midi_for_light.VolumeBeatSperreTimer = engine.beginTimer(1000,"midi_for_light.VolumeBeatSperre()");
	}
}

midi_for_light.VolumeBeatSperre = function() { // eine Sekunde Deckwechsel verhindern
	engine.stopTimer(midi_for_light.VolumeBeatSperreTimer);
	midi_for_light.volumebeatsperre = false;
	midi.sendShortMsg(0x90,0x30,0x0);   // Note C an mit 0
	midi.sendShortMsg(0x80,0x30,0x0);   // Note C off mit 0
	midi_for_light.Deck1VolumeChange();      // Schauen ob Deck noch aktuell ist
}

midi_for_light.VolumeBeatOnVerzoegerung = function() { // Deckwechsel mit Deckvolume erst nach drei Sekunden erlauben
	engine.stopTimer(midi_for_light.VolumeBeatOnVerzoegerungTimer);
	midi_for_light.volumebeat = true;
}

midi_for_light.CrossfaderChange = function() { // Crossfader wurde bewegt, Deck pruefen;
	// Falls Fadersperre, gleich raus
	if (midi_for_light.fadersperre == true) {
		return;
	}

  // Pruefe Umstellung Decksteuerung auf Volume-Deck
  midi_for_light.volumebeat = false;
	engine.stopTimer(midi_for_light.VolumeBeatOnVerzoegerungTimer);
	if (engine.getValue("[Master]", "crossfader") > -0.25) { // Fader ist 25% links von Null;
    if (engine.getValue("[Master]", "crossfader") < 0.25) { // Fader ist 25% lin von Null;
      //midi_for_light.volumebeat = true;
      midi_for_light.VolumeBeatOnVerzoegerungTimer = engine.beginTimer(3000,"midi_for_light.VolumeBeatOnVerzoegerung()");
		}
	}

	// Falls Fader in Mittelstellung, nichts machen und raus
	if (engine.getValue("[Master]", "crossfader") == 0) {
		return;
	}

	// Aktuelles Deck ermitteln, 0-Position = links
	var deck = 0; 
	if (engine.getValue("[Master]", "crossfader") > 0) { // Fader ist Rechts und nicht mittig
		deck = 1;
	}

	// Schauen ob das Deck gewechselt hat
	if (deck != midi_for_light.deckaktuell){
		midi_for_light.deckaktuell = deck;
		midi.sendShortMsg(0x90,0x30,0x64+deck);   // Note C an mit 64 und Deck dazu addiert
		midi_for_light.fadersperre = true;
		midi_for_light.CrossfaderChangeSperreTimer = engine.beginTimer(1000,"midi_for_light.CrossfaderChangeSperre()");
	}
}

midi_for_light.CrossfaderChangeSperre = function() { // eine Sekunde Deckwechsel verhindern
	engine.stopTimer(midi_for_light.CrossfaderChangeSperreTimer);
	midi_for_light.fadersperre = false;
	midi.sendShortMsg(0x90,0x30,0x0);   // Note C an mit 0
	midi.sendShortMsg(0x80,0x30,0x0);   // Note C off mit 0
	midi_for_light.CrossfaderChange();       // Schauen ob Deck noch aktuell ist
}

midi_for_light.Deck1PostionChange = function() { // Playposition hat sich geaendert
	if (midi_for_light.deckaktuell == 0) { // aktuelles Deck pruefen
		midi_for_light.SendMidiMtcFullframe("[Channel1]");
	}
}

midi_for_light.Deck2PostionChange = function() { // Playposition hat sich geaendert
	if (midi_for_light.deckaktuell == 1) { // aktuelles Deck pruefen
		midi_for_light.SendMidiMtcFullframe("[Channel2]");
	}
}

midi_for_light.SendMidiMtcFullframe = function(deck) { // Sendet einen MTC full Frame
	var fps = 2; // 2 = 25 FPS
	var PlayPositionRest = engine.getValue(deck, "duration") * engine.getValue(deck, "playposition");
	if (PlayPositionRest < 0) {
		PlayPositionRest = 0;
	}
	// Stunden-Position berechnen und von PlayPositionRest abziehen 
	var hr = Math.floor(PlayPositionRest / 3600);
	PlayPositionRest = PlayPositionRest - (hr * 3600);
	// Minuten-Position berechnen und von PlayPositionRest abziehen
	var mn = Math.floor(PlayPositionRest / 60);
	PlayPositionRest = PlayPositionRest - (mn * 60);
	// Sekunden-Position berechnen und von PlayPositionRest abziehen
	var ss = Math.floor(PlayPositionRest);
	PlayPositionRest = PlayPositionRest - ss;
	// Frame-Position berechnen und von PlayPositionRest abziehen
	var fr = Math.floor(PlayPositionRest * 25);
  // Sysex-Frame zusammensetzen und raus damit
	var fullframe = [0xf0,0x7f,0x7f,0x01,0x01,(16 * fps) + hr,mn,ss,fr,0xf7];
	midi.sendSysexMsg(fullframe,10);
}

midi_for_light.Deck1BeatOutputToMidi = function() { // Midi-Note senden bei Beatereignis
  var deckbpm = engine.getValue("[Channel1]", "bpm")-50;
  if (deckbpm <= 0) {
    deckbpm = 0;
  }
  if (deckbpm >= 127) {
    deckbpm = 127;
  }
  if (midi_for_light.deckaktuell == 0) { // raus wenn es nicht das aktuelle Deck ist
		if (engine.getValue("[Channel1]", "beat_active") == true ) { // Beat ist an, sende Note an
			midi.sendShortMsg(0x90,0x32,0x64);   // Note D an mit 64
			midi.sendShortMsg(0x90,0x34,deckbpm);   // Note E an mit BPM-Wert senden
		} else { // Beat ist aus, sende Note aus
			midi.sendShortMsg(0x90,0x32,0x0);   // Note D an mit 0
			midi.sendShortMsg(0x80,0x32,0x0);   // Note D off mit 0
		}
	}
}

midi_for_light.Deck2BeatOutputToMidi = function() { // Midi-Note senden bei Beatereignis
  var deckbpm = engine.getValue("[Channel2]", "bpm")-50;
  if (deckbpm <= 0) {
    deckbpm = 0;
  }
  if (deckbpm >= 127) {
    deckbpm = 127;
  }
  if (midi_for_light.deckaktuell == 1) { // raus wenn es nicht das aktuelle Deck ist
		if (engine.getValue("[Channel2]", "beat_active") == true ) { // Beat ist an, sende Note an
			midi.sendShortMsg(0x90,0x32,0x64);   // Note D an mit 64
			midi.sendShortMsg(0x90,0x34,deckbpm);   // Note E an mit BPM-Wert senden
		} else { // Beat ist aus, sende Note aus
			midi.sendShortMsg(0x90,0x32,0x0);   // Note D an mit 0
			midi.sendShortMsg(0x80,0x32,0x0);   // Note D off mit 0
		}
	}
}

// ----------- Beispiel & Source WWW
// http://mixxx.org/wiki/doku.php/midi_scripting  bei MyController.elapsedTime = function (deck) {
// http://mixxx.org/wiki/doku.php/mixxxcontrols
